<!--
  ~ Copyright (c) 2024 LOBA
  ~ 
  ~ Permission is hereby granted, free of charge, to any person obtaining a copy of
  ~ this software and associated documentation files (the "Software"), to deal in
  ~ the Software without restriction, including without limitation the rights to
  ~ use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
  ~ the Software, and to permit persons to whom the Software is furnished to do so,
  ~ subject to the following conditions:
  ~ 
  ~ The above copyright notice and this permission notice shall be included in all
  ~ copies or substantial portions of the Software.
  ~ 
  ~ THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  ~ IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
  ~ FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
  ~ COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
  ~ IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  ~ CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
  ~ 
  ~ SPDX-License-Identifier: MIT
  ~ 
  ~ Contributors:
  ~     [name] - [contribution]
-->

<template>
    <div v-if="selectedMethod === 'streaming'" class="method-streaming">
        <div class="field field-modal-big-label">
            <label for="" class="label">Configuration</label>
        </div>
        <form id="dataset-step-2-streaming" @submit.prevent="handleSubmitStreaming">
            <div class="modal-input col">
                <label for="file_name">File Name</label>
                <input type="text" name="file_name" id="file_name" minlength="3" required/>
            </div>
            <div class="modal-boxs-wrapper">
                <CustomSelect class="col-100" :options="protocolOptions"
                    defaultTitle="Protocol type" defaultValue="protocoltype"
                    @selected="handleSelect" required data-error-message="Fill in this field." />
            </div>
            <div class="modal-boxs-wrapper" v-if="isOptionSelected">
                <div class="modal-input col">
                    <label for="mqtt">Host</label>
                    <input type="text" name="host" id="host" minlength="3" required data-error-message="Fill in this field." />
                </div>
                <CustomSelect class="col" :options="portOptions" defaultTitle="Port"
                    defaultValue="port" minlength="3" required data-error-message="Fill in this field." />
                <div class="modal-input col">
                    <label for="topic">Topic</label>
                    <input type="text" name="topic" id="topic" required data-error-message="Fill in this field." />
                </div>
                <div class="modal-input col">
                    <label for="user">User</label>
                    <input type="text" name="user" id="user" minlength="3" required data-error-message="Fill in this field." />
                </div>
                <div class="modal-input col">
                    <label for="password">Password</label>
                    <input type="password" name="password" id="password" minlength="3"
                        required data-error-message="Fill in this field." />
                </div>
                <div class="modal-boxs-wrapper col" v-if="selectedProtocol === 'MQTT'">
                    <div class="modal-input col input-checkbox">
                        <div class="form-group-checkbox">
                            <input type="checkbox" name="include-topic"
                                id="include-topic" />
                            <div class="checkbox__checkmark"></div>
                            <label for="include-topic">Include Topic</label>
                        </div>
                    </div>
                    <div class="modal-input col input-checkbox">
                        <div class="form-group-checkbox">
                            <input type="checkbox" name="include-timestamp"
                                id="include-timestamp" />
                            <div class="checkbox__checkmark"></div>
                            <label for="include-timestamp">Include Timestamp</label>
                        </div>
                    </div>
                </div>
                <div class="modal-boxs-wrapper col-100">
                    <div class="modal-input col input-radio">
                        <input type="radio" id="shipping-frequency" name="consolidation"
                            value="shipping-frequency" v-model="selectedConsolidation">
                        <label for="shipping-frequency">Shipping Frequency</label>
                    </div>
                    <div class="modal-input col input-radio">
                        <input type="radio" id="upload-size" name="consolidation"
                            value="upload-size" v-model="selectedConsolidation">
                        <label for="upload-size">Upload Size</label>
                    </div>
                </div>
                <CustomSelect v-if="selectedConsolidation" class="col-100"
                    :options="selectOptions" :defaultTitle="selectTitle"
                    name="selected_consolidation"
                    @selected="selected_consolidation_value" />
                <!-- <CustomSelect class="col" :options="fileType" defaultTitle="File type"
                    name="file_type" @selected="file_type_value" />
                <div class="modal-input col">
                    <label for="field-delimiter">Field Delimiter</label>
                    <input type="text" name="field_delimiter" id="field_delimiter">
                </div>
                <div class="modal-input col">
                    <label for="decimal_delimiter">Decimal Delimiter</label>
                    <input type="text" name="decimal_delimiter" id="decimal_delimiter">
                </div> -->
            </div>
        </form>
    </div>
    <ClientOnly>
        <Teleport to="#modals-container">
            <ModalsModalFeedback v-if="showFeedback" :feedback="feedbackMessage" @toggle="close"/>
        </Teleport>
    </ClientOnly>
</template>

<script setup lang="ts">

import { generateUUID, highlightInvalidFields, updateLoadingUI, clearAllValidationErrors } from '~/utils/utils';
import { ref } from 'vue';

// Define the component's props
// - selectedMethod: A string indicating the currently selected method (e.g., streaming)
// - createdDatasetId: The ID of the dataset that has been created
// - currentStep: The current step in the process (used for navigation)
// - datasetName: The name of the dataset being processed
// - nextStep: A required function to move to the next step in the process
const props = defineProps({
    selectedMethod: String,
    createdDatasetId: String,
    currentStep: Number,
    datasetName: String,
    nextStep: {
        type: Function,
        required: true,
    },
    showFeedback: Boolean,
    feedbackMessage: Object,
});

const feedbackMessage = ref({ type: '', message: '' });
const showFeedback = ref(false);

const close = () => {
    showFeedback.value = false;
};


// Reactive reference for available protocol options (e.g., MQTT, Kafka)
const protocolOptions = ref([
    {
        id: 1,
        name: 'MQTT',
    },
    {
        id: 2,
        name: 'Kafka',
    }
]);

// Reactive reference for available port options
const portOptions = ref([
    {
        id: 1,
        name: '3000',
    },
    {
        id: 2,
        name: '8000',
    },
    {
        id: 3,
        name: '1883',
    }
]);

// Reactive references for tracking selected options and states
const isOptionSelected = ref<boolean>(false); // Indicates if an option is selected
const selectedProtocol = ref(''); // Holds the currently selected protocol


/**
 * Handles the selection of a protocol from the dropdown list. Updates the 
 * 'isOptionSelected' and 'selectedProtocol' reactive references accordingly.
 * 
 * @param {string} selectedOption - The selected protocol option
 */
const handleSelect = (selectedOption: string) => {
    isOptionSelected.value = selectedOption !== '';
    selectedProtocol.value = selectedOption;
}

// Reactive reference for selected consolidation type
const selectedConsolidation = ref('');

// Options for shipping frequency and upload size consolidation types
const shippingFrequencyOptions = [
    { id: 1, name: '30' },
    { id: 2, name: '60' },
    { id: 3, name: '90' },
];

const uploadSizeOptions = [
    { id: 1, name: '200' },
    { id: 2, name: '300' },
    { id: 3, name: '500' },
];

// Computed property that returns the relevant options based on the selected consolidation type
const selectOptions = computed(() => {
    if (selectedConsolidation.value === 'shipping-frequency') {
        return shippingFrequencyOptions;
    } else if (selectedConsolidation.value === 'upload-size') {
        return uploadSizeOptions;
    } else {
        return [];
    }
});

// Computed property that provides a title for the selection based on the consolidation type
const selectTitle = computed(() => {
    if (selectedConsolidation.value === 'shipping-frequency') {
        return 'Select Shipping Frequency Value';
    } else if (selectedConsolidation.value === 'upload-size') {
        return 'Select Upload Size Value';
    } else {
        return 'Consolidation Value';
    }
});

// Reactive reference for the selected consolidation value
const selected_consolidation = ref('');
/**
 * Handles changes to the selected consolidation value, updating the reactive reference
 * @param {any} event The event containing the new value
 */
const selected_consolidation_value = (event: any) => {
    selected_consolidation.value = event;
}

/**
 * Handles the submission of the form for creating a dataset using the streaming method. The function
 * validates the form, creates a new artifact with the selected protocol and consolidation type, and
 * then submits the data to the server. If the submission is successful, the function resets the form
 * and moves to the next step in the process. If the submission fails, the function shows an error
 * message and remains on the same step.
 */
const handleSubmitStreaming = async () => {
    const form = document.getElementById('dataset-step-2-streaming') as HTMLFormElement;

    if (props.currentStep === 2 && form) {
        if (!form.checkValidity()) {
            // Check form validity
            form.reportValidity();
            highlightInvalidFields(form);
            console.log('Form is invalid, showing error messages or highlighting fields.');
            return;
        }

        const formData = new FormData(form); // Create a FormData object from the form
        const uuid = generateUUID(); // Generate a unique ID for the submission

        // Prepare source data based on the selected protocol
        const source_data: any = {
            source_type: selectedProtocol.value.toLowerCase(),
        };

        // Populate source_data based on selected protocol
        if (selectedProtocol.value === 'MQTT') {
            source_data.mqtt_host = formData.get('host') as string;
            source_data.mqtt_port = formData.get('port') as string;
            source_data.topic = formData.get('topic') as string;
            source_data.include_topic = formData.get('include-topic') === 'on' ? true : false;
            source_data.include_timestamp = formData.get('include-timestamp') === 'on' ? true : false;
        } else if (selectedProtocol.value === 'Kafka') {
            source_data.kafka_host = formData.get('host') as string;
            source_data.kafka_port = formData.get('port') as string;
            source_data.kafka_topic = formData.get('topic') as string;
        }

        // Determine consolidation_type based on selectedConsolidation
        let consolidation_type = '';
        if (selectedConsolidation.value === 'shipping-frequency') {
            consolidation_type = 'TIME';
        } else if (selectedConsolidation.value === 'upload-size') {
            consolidation_type = 'SIZE';
        }

        // Prepare the data object for submission
        const data = {
            name: formData.get('file_name') as string,
            file_type: 'csv',
            consolidation_type: consolidation_type,
            consolidation_value: selected_consolidation.value,
            resource_name: 'generator',
            dataset_id: props.createdDatasetId,
            // field_delimiter: formData.get('field_delimiter') as string,
            // decimal_delimiter: formData.get('decimal_delimiter') as string,
            source_data,
            id: uuid,
        };

        // Show loading state while submitting
        updateLoadingUI(true);

        try {
            // Submit the streaming data
            await submitDataStreaming(data);
            console.log('Data submitted successfully Streaming:', data);
            form.reset(); // Reset the form after successful submission
            clearAllValidationErrors(form);
            //props.nextStep();
        } catch (error) {
            console.error('Error during data submission:', error);
        } finally {
            updateLoadingUI(false);
        }

    } else {
        props.nextStep();
    }

}

/**
 * Submits the streaming data to the API.
 *
 * @param {object} data - The data object to be submitted. It should have the
 *     following properties:
 *     - name: The name of the dataset.
 *     - file_type: The type of the file (csv, json, etc.).
 *     - consolidation_type: The type of consolidation (TIME, SIZE, etc.).
 *     - consolidation_value: The value for the consolidation type.
 *     - resource_name: The name of the resource (generator, etc.).
 *     - dataset_id: The ID of the dataset.
 *     - source_data: The source data object.
 *     - id: The ID of the streaming.
 *
 * @returns {Promise<void>} A promise that resolves when the submission is
 *     complete, or rejects if there is an error.
 */
const submitDataStreaming = async (data: any) => {
    const apiBaseUrl = useRuntimeConfig().public.API_DATAMITE_URL_V2 as string;

    try {
    
        // Send a POST request to submit the data
        useFetchAuth('/streamings/', {
            method: 'POST',
            headers: {
                'Content-Type': 'application/json'
            },
            body: JSON.stringify(data)
        }, apiBaseUrl).then((response: any) => {
            if (!response.id) {
                showFeedback.value = true;
                feedbackMessage.value = {
                    type: 'error',
                    message: 'Error creating streaming pipeline:' + response,
                };
                console.error('Streaming ID not found in response:', response);
            }

            useFetchAuth('/streamings/' + response.id + '/start', {
                method: 'PUT'
            }, useRuntimeConfig().public.API_DATAMITE_STREAMING_SERVICE).then((response: any) => {
                showFeedback.value = true;
                feedbackMessage.value = {
                    type: 'success',
                    message: 'Dataset created successfully!',
                };
                setTimeout(() => {
                    feedbackMessage.value = { type: '', message: '' };
                    showFeedback.value = false;
                    props.nextStep();
                    updateLoadingUI(false); // Stop the loading indicator
                }, 3000);
            }).catch((error: any) => {
                const errorData = error.response._data.message || error;
                console.log('Error starting streaming pipeline:', errorData);
                showFeedback.value = true;
                feedbackMessage.value = {
                    type: 'error',
                    message: 'Error creating streaming pipeline:' + errorData,
                };
            });
        });
        
    } catch (error: any) {
        // Handle errors from the submission process
        if (error.response) {
            const errorData = error.response._data.message || error;
            showFeedback.value = true;
            feedbackMessage.value = {
                type: 'error',
                message: 'Error creating streaming pipeline:' + errorData,
            };
            console.error('Error submitting data:', error.response.status, error.response._data || error.message);
        } else {
            const errorData = error.response._data.message || error;
            showFeedback.value = true;
            feedbackMessage.value = {
                type: 'error',
                message: 'Error creating streaming pipeline:' + errorData,
            };
            console.error('Error during fetch:', error.message || error);
        }
    }
};

// Expose the handleSubmitStreaming and submitDataStreaming method to the parent component
defineExpose({
    handleSubmitStreaming,
    submitDataStreaming
});

</script>